/***************************************************************************

  BionxControl
  Copyright © 2025 christoph holzheuer
  christoph.holzheuer@gmail.com

  Using:

  mhs_can_drv.c
  © 2011 - 2023 by MHS-Elektronik GmbH & Co. KG, Germany
  Klaus Demlehner, klaus@mhs-elektronik.de
  @see www.mhs-elektronik.de

  Based on Bionx data type descriptions from:

  BigXionFlasher USB V 0.2.4 rev. 97
  © 2011-2013 by Thomas Koenig <info@bigxionflasher.org>
  @see www.bigxionflasher.org

  Bionx Bike Info
  © 2018 Thorsten Schmidt (tschmidt@ts-soft.de)
  @see www.ts-soft.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  @see https://github.com/bikemike/bionx-bikeinfo

 ***************************************************************************/


#ifndef BCVALUEMODEL_H
#define BCVALUEMODEL_H

#include <QAbstractTableModel>
#include <bcvalue.h>

/**
 * @brief Das BCValueModel dient als Interface zu den eigentlichen Daten,
 * der BCValueList und besitzt diese.
 *
 * Ist das so schlau?
 *
 */

class BCValueModel : public QAbstractTableModel
{
  Q_OBJECT

public:

  explicit BCValueModel(QObject *parent = nullptr);

  void setHeaderLabel( const QString& headerLabel );

  void addValue(const BCValue& val);
  void takeValueList(BCValueList& valueList);
  const BCValueList& getValueList() const;

  // Pure Virtual Functions von QAbstractTableModel
  int rowCount(const QModelIndex& parent = QModelIndex()) const override;
  int columnCount(const QModelIndex& parent = QModelIndex()) const override;

  QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
  QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const override;

  // Nötig für Editierbarkeit
  Qt::ItemFlags flags(const QModelIndex& index) const override;
  bool setData(const QModelIndex& index, const QVariant& value, int role = Qt::EditRole) override;

public slots:

  void onValueUpdated(int index, BC::State state, const QString& newVisisbleValue="" );

protected:

  QString     _headerLabel;
  // Die eigentlichen Werte wohnen im tatsächlich hier, im Model.
  BCValueList _valueList;

};

#endif // BCVALUEMODEL_H
